SystemOrganization addCategory: #'Seaside-Tests-Component-Tests'!
SystemOrganization addCategory: #'Seaside-Tests-Component-Mocks'!

WADecoration subclass: #WADecorationMock
	instanceVariableNames: 'initialRequestBlock updateRootBlock updateUrlBlock updateStatesBlock renderBlock childrenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Component-Mocks'!

!WADecorationMock methodsFor: 'accessing' stamp: 'lr 11/4/2008 10:00'!
children
	^ childrenBlock isNil
		ifTrue: [ super children ]
		ifFalse: [ super children , childrenBlock value ]! !

!WADecorationMock methodsFor: 'initialization' stamp: 'lr 10/22/2008 22:34'!
initialRequest: aRequest
	super initialRequest: aRequest.
	initialRequestBlock isNil
		ifFalse: [ initialRequestBlock value: aRequest ]! !

!WADecorationMock methodsFor: 'events' stamp: 'lr 11/4/2008 10:00'!
onChildren: aBlock
	childrenBlock := aBlock! !

!WADecorationMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:34'!
onInitialRequest: aBlock
	initialRequestBlock := aBlock! !

!WADecorationMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:34'!
onRender: aBlock
	renderBlock := aBlock! !

!WADecorationMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:34'!
onUpdateRoot: aBlock
	updateRootBlock := aBlock! !

!WADecorationMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:34'!
onUpdateStates: aBlock
	updateStatesBlock := aBlock! !

!WADecorationMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:34'!
onUpdateUrl: aBlock
	updateUrlBlock := aBlock! !

!WADecorationMock methodsFor: 'rendering' stamp: 'lr 10/22/2008 22:35'!
renderContentOn: html
	renderBlock isNil 
		ifTrue: [ super renderContentOn: html ]
		ifFalse: [ renderBlock value: html value: [ super renderContentOn: html ] ]! !

!WADecorationMock methodsFor: 'updating' stamp: 'lr 10/22/2008 22:34'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	updateRootBlock isNil
		ifFalse: [ updateRootBlock value: aHtmlRoot ]! !

!WADecorationMock methodsFor: 'updating' stamp: 'lr 10/22/2008 22:34'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	updateStatesBlock isNil
		ifFalse: [ updateStatesBlock value: aSnapshot ]! !

!WADecorationMock methodsFor: 'updating' stamp: 'lr 10/22/2008 22:34'!
updateUrl: aUrl
	super updateUrl: aUrl.
	updateUrlBlock isNil
		ifFalse: [ updateUrlBlock value: aUrl ]! !

!WAPackage class methodsFor: '*Seaside-Tests-Component' stamp: 'lr 10/23/2008 21:31'!
seasideTestsComponent
	^ self new
		name: 'Seaside-Tests-Component';
		description: 'Unit tests for the package Seaside-Component.';
		addDependency: 'Seaside-Component';
		addDependency: 'Seaside-Tests-Core';
		yourself! !

WAComponent subclass: #WAComponentMock
	instanceVariableNames: 'initialRequestBlock updateRootBlock updateUrlBlock updateStatesBlock renderBlock childrenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Component-Mocks'!

!WAComponentMock methodsFor: 'accessing' stamp: 'lr 10/22/2008 22:29'!
children
	^ childrenBlock isNil
		ifTrue: [ super children ]
		ifFalse: [ childrenBlock value ]! !

!WAComponentMock methodsFor: 'initialization' stamp: 'lr 10/22/2008 22:24'!
initialRequest: aRequest
	super initialRequest: aRequest.
	initialRequestBlock isNil
		ifFalse: [ initialRequestBlock value: aRequest ]! !

!WAComponentMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:28'!
onChildren: aBlock
	childrenBlock := aBlock! !

!WAComponentMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:28'!
onInitialRequest: aBlock
	initialRequestBlock := aBlock! !

!WAComponentMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:23'!
onRender: aBlock
	renderBlock := aBlock! !

!WAComponentMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:23'!
onUpdateRoot: aBlock
	updateRootBlock := aBlock! !

!WAComponentMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:23'!
onUpdateStates: aBlock
	updateStatesBlock := aBlock! !

!WAComponentMock methodsFor: 'events' stamp: 'lr 10/22/2008 22:23'!
onUpdateUrl: aBlock
	updateUrlBlock := aBlock! !

!WAComponentMock methodsFor: 'rendering' stamp: 'lr 10/22/2008 22:25'!
renderContentOn: html
	renderBlock isNil 
		ifTrue: [ super renderContentOn: html ]
		ifFalse: [ renderBlock value: html ]! !

!WAComponentMock methodsFor: 'updating' stamp: 'lr 10/22/2008 22:28'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	updateRootBlock isNil
		ifFalse: [ updateRootBlock value: aHtmlRoot ]! !

!WAComponentMock methodsFor: 'updating' stamp: 'lr 10/22/2008 22:27'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	updateStatesBlock isNil
		ifFalse: [ updateStatesBlock value: aSnapshot ]! !

!WAComponentMock methodsFor: 'updating' stamp: 'lr 10/22/2008 22:28'!
updateUrl: aUrl
	super updateUrl: aUrl.
	updateUrlBlock isNil
		ifFalse: [ updateUrlBlock value: aUrl ]! !

TestCase subclass: #WAComponentTest
	instanceVariableNames: 'log component root decoration1 decoration2 child1 child2 child3 child4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Component-Tests'!

!WAComponentTest methodsFor: 'private' stamp: 'lr 10/22/2008 22:52'!
assertLog: anArray
	self
		assert: log asArray = anArray
		description: 'Expected ' , anArray printString , ', but got ' , log asArray printString.
	log := OrderedCollection new! !

!WAComponentTest methodsFor: 'private' stamp: 'lr 10/22/2008 22:47'!
log: aString
	log add: aString! !

!WAComponentTest methodsFor: 'running' stamp: 'lr 11/4/2008 10:08'!
setUp
	super setUp.
	log := OrderedCollection new.
	root := WAComponentMock new.
	decoration1 := WADecorationMock new.
	decoration2 := WADecorationMock new.
	child1 := WAComponentMock new.
	child2 := WAComponentMock new.
	child3 := WAComponentMock new.
	child4 := WAComponentMock new! !

!WAComponentTest methodsFor: 'testing' stamp: 'lr 11/4/2008 10:09'!
testActiveComponent

	" single root component "
	self assert: root activeComponent = root.

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2.

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2.
	
	" delegate to another component "
	child2 show: child3.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child3.
	self assert: child3 activeComponent = child3.
	
	" delegate to yet another component "
	child3 show: child4.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child4.
	self assert: child3 activeComponent = child4.
	self assert: child4 activeComponent = child4
	! !

!WAComponentTest methodsFor: 'testing' stamp: 'lr 11/4/2008 10:12'!
testHome
	root show: child1.
	child1 show: child2.
	self assert: root activeComponent = child2.
	self assert: child1 activeComponent = child2.
	
	root home.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child2.
	self assert: child2 activeComponent = child2.
	
	child1 home.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2.
	
	child2 home.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2! !

!WAComponentTest methodsFor: 'testing' stamp: 'jf 11/3/2008 16:19'!
testInitialRequest
	| request guide |
	request := WARequest new.

	root onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'root' ].
	child1 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'child1' ].
	child2 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'child2' ].
	child3 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'child3' ].
	decoration1 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'decoration1' ].
	decoration2 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'decoration2' ].

	guide := WAAllPresenterGuide client: (WAInitialRequestVisitor request: request).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3' 'child2')! !

!WAComponentTest methodsFor: 'testing' stamp: 'lr 11/4/2008 11:57'!
testRendering
	| context guide |
	context := WARenderingContext new.
	guide := WARenderingGuide client: (WARenderVisitor context: context).
	
	root onRender: [ :html |
		self assert: html context = context.
		self log: 'root' ].
	child1 onRender: [ :each |
		self assert: each context = context.
		self log: 'child1' ].
	child2 onRender: [ :html |
		self assert: html context = context.
		self log: 'child2' ].
	child3 onRender: [ :html |
		self assert: html context = context.
		self log: 'child3' ].
	decoration1 onRender: [ :html :cc |
		self assert: html context = context.
		self log: 'decoration1'.
		cc value ].
	decoration2 onRender: [ :html :cc |
		self assert: html context = context.
		self log: 'decoration2'.
		cc value ].

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	root onRender: [ :html | 
		self log: 'root'.
		self assert: html context = context.
		html render: child1; render: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3')! !

!WAComponentTest methodsFor: 'testing' stamp: 'jf 11/3/2008 16:16'!
testUpdateRoot
	| htmlRoot guide |
	htmlRoot := WAHtmlRoot new.

	root onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'root' ].
	child1 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'child1' ].
	child2 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'child2' ].
	child3 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'child3' ].
	decoration1 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'decoration1' ].
	decoration2 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'decoration2' ].

	guide := WAVisiblePresenterGuide client: (WAUpdateRootVisitor root: htmlRoot).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3')! !

!WAComponentTest methodsFor: 'testing' stamp: 'jf 11/3/2008 16:13'!
testUpdateStates
	| snapshot guide |
	snapshot := WASnapshot new.

	root onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'root' ].
	child1 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'child1' ].
	child2 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'child2' ].
	child3 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'child3' ].
	decoration1 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'decoration1' ].
	decoration2 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'decoration2' ].

	guide := WAAllPresenterGuide client: (WAUpdateStatesVisitor snapshot: snapshot).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3' 'child2')! !

!WAComponentTest methodsFor: 'testing' stamp: 'jf 11/3/2008 16:10'!
testUpdateUrl
	| url guide |
	url := WAUrl new.

	root onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'root' ].
	child1 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'child1' ].
	child2 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'child2' ].
	child3 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'child3' ].
	decoration1 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'decoration1' ].
	decoration2 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'decoration2' ].

	guide := WAVisiblePresenterGuide client: (WAUpdateUrlVisitor url: url).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3')! !
